﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class RaceManager : MonoBehaviour {

	[SerializeField]
	CarController[]		m_cars;		// 車を配列で管理

	int[] m_sameScoreArray;			// 同じスコアの車を納める配列
	// Use this for initialization
	void Start () {
		m_sameScoreArray = new int[m_cars.Length];
	}
	
	// Update is called once per frame
	void Update () {

		int rank = CheckPlayerRank ();
		Debug.Log("Player Rank is " + (rank+1));

			
	}

	/// <summary>
	/// プレイヤーの順位チェック
	/// </summary>
	/// <returns>The player rank.</returns>
	int CheckPlayerRank()
	{
		// プレイヤーが配列の0番目として順位を求める
		int sameScoreNum = 0;
		int rank = 0;
		for (int i = 1; i < m_cars.Length; i++) {
			// プレイヤーの方がスコアが低い
			if (m_cars [0].RankScore < m_cars [i].RankScore) {
				rank++;
			}
			// 同じスコア
			else if (m_cars [0].RankScore == m_cars [i].RankScore) {
				m_sameScoreArray [sameScoreNum] = i;
				sameScoreNum++;
			}
		}

		// 同じスコアの敵がいた場合
		if (sameScoreNum > 0) {
			int sameScoreRank = 0;
			for (int i = 0; i < sameScoreNum; i++) {
				if (m_cars[0].CheckPointPassingTime > m_cars[m_sameScoreArray[i]].CheckPointPassingTime)
				{
					sameScoreRank++;
				}
			}
			rank += sameScoreRank;
		}


		return rank;
	}
}
